
#ifndef __SPIKE_H
#define __SPIKE_H


#include "../util/Vector.h"

#pragma pack(1)

class CSpike {
public:
	CSpike() { };
	CSpike( float x, float y, float z, float dx, float dy, float dz );
	CSpike( const SVector& or, const SVector& dir );
	CSpike( const CSpike& s );

	const SVector& getOrigin() const { return mOrigin; }
	SVector& getOrigin() { return mOrigin; }

	const SVector& getDirection() const { return mDirection; }
	SVector& getDirection() { return mDirection; }

private:
	SVector	mOrigin;
	SVector	mDirection;
};

#pragma pack()



inline CSpike::CSpike( float x, float y, float z, float dx, float dy, float dz )
:	mOrigin( x, y, z ),
	mDirection( dx, dy, dz )
{
}

inline CSpike::CSpike( const SVector& or, const SVector& dir )
:	mOrigin( or ),
	mDirection( dir )
{
}

inline CSpike::CSpike( const CSpike& s )
:	mOrigin( s.mOrigin ),
	mDirection( s.mDirection )
{
}


#endif

