
#ifndef __SPIKE_RENDERERS_H
#define __SPIKE_RENDERERS_H

#include "Spike.h"
#include "../render/Canvas.h"
#include "../render/Drawing.h"

class CRandom;


class CBaseSpikeRenderer {
public:
	CBaseSpikeRenderer( bool dark )
		: mDark( dark ) { }

	void begin( CDrawing& draw, CCanvas& color, CCanvas& depth, float zrange )
		{ mDrawing = &draw; mColor = &color; mDepth = &depth; mZRange = zrange; mFogMult = 255.0f / mZRange; }
	
protected:
	CDrawing*	mDrawing;
	CCanvas*	mColor;
	CCanvas*	mDepth;
	float		mZRange;
	float		mFogMult;
	bool		mDark;
};


class CLineRenderer : public CBaseSpikeRenderer {
public:
	CLineRenderer( bool dark ) : CBaseSpikeRenderer( dark ) { }
	void renderSpike( const CSpike& spike, const SVector& v1, const SVector& v2, float scale );
};

class CFuzzyLineRenderer : public CBaseSpikeRenderer {
public:
	CFuzzyLineRenderer( bool dark ) : CBaseSpikeRenderer( dark ) { }
	void renderSpike( const CSpike& spike, const SVector& v1, const SVector& v2, float scale );
private:
	static CRandom	mRandom;
};



#endif

