
#ifndef __MEMORY_CHECKER_H
#define __MEMORY_CHECKER_H


#define WIN32_LEAN_AND_MEAN
#include <windows.h>


class CMemoryChecker {
public:
	CMemoryChecker();
	
	int	consumed();
	
	void reserve( int kbytes ) { mReserved += kbytes; }
	void reserveConsumed() { reserve( consumed() ); }
	
	bool isEnding() const { return mCurrentFree <= mReserved; }
	int  getMemoryLeft() const { return mCurrentFree - mReserved; }
	int  getRealMemoryLeft() const { return mCurrentFree; }
	
private:
	int		mCurrentFree;
	int		mReserved;
	MEMORYSTATUS	mMemoryStatus;
};


inline CMemoryChecker::CMemoryChecker()
{
	GlobalMemoryStatus(&mMemoryStatus);
	mCurrentFree = mMemoryStatus.dwAvailPageFile / 1024;
	mReserved = 1024; // just in case
	//mCurrentFree = 128 * 1024;
}

inline int CMemoryChecker::consumed()
{
	GlobalMemoryStatus(&mMemoryStatus);
	int cf = mMemoryStatus.dwAvailPageFile / 1024;
	int cons = mCurrentFree - cf;
	mCurrentFree = cf;
	return cons;
	//return 0;
}

#endif
