
#ifndef __RANDOM_H
#define __RANDOM_H


//------------------------------------------------------------------------
// CRandom

class CRandom {
public:
	CRandom() { seed(); };
	CRandom( int ij, int kl = 0 ) { seed( ij, kl ); };
	void	seed( int ij = 0, int kl = 0 );
	int		getInt();
	float	getFloat();

private:
	enum { RAN_COEF = 4096*4096 };
	enum { MAX_IJ = 31328 };
	enum { MAX_KL = 30081 };
	enum { TABLE_SIZE = 98 };
private:
	int		mTable[ TABLE_SIZE ];
	int		mC, mCD, mCM;
	int		mI, mJ;
};

inline int CRandom::getInt()
{
	int uni;
	uni = mTable[mI] - mTable[mJ];
	if( uni < 0 ) uni += RAN_COEF;
	mTable[mI] = uni;
	mI--;		if( !mI )		mI = TABLE_SIZE-1;
	mJ--;		if( !mJ )		mJ = TABLE_SIZE-1;
	mC -= mCD;	if( mC < 0 )	mC += mCM;
	uni -= mC;
	if( uni < 0 ) uni += RAN_COEF;
	return uni;
}

inline float CRandom::getFloat()
{
	int r = getInt();
	return (float)(r & 0xFFFF) / 65536.0f;
}


//------------------------------------------------------------------------
// CSingletonRandom

class CSingletonRandom {
public:
	static CRandom& getRandom() {
		static CRandom r;
		return r;
	}
private:
	CSingletonRandom() { }
};

#endif
