
#ifndef __TIME_CHECKER_H
#define __TIME_CHECKER_H


#define WIN32_LEAN_AND_MEAN
#include <windows.h>


class CTimeChecker {
public:
	CTimeChecker( double allowedSeconds );

	double	elapsed();

	void reserve( double secs ) { mEndTime -= secs; }
	void reserveElapsed() { reserve( elapsed() ); }

	bool isDeadline() const { return mCurrentTime >= mEndTime; }
	double  getTimeLeft() const { return mEndTime - mCurrentTime; }
	double  getRealTimeLeft() const { return mRealEndTime - mCurrentTime; }

private:
	double getTimer() const;
	
public:
	double mStartTime;
	double mEndTime;
	double mCurrentTime;
	double mRealEndTime;

	double	mClockFreq;
};



#endif
